//+------------------------------------------------------------------+
//|                                    TrendEnvelopes_v6.mq4         |
//+------------------------------------------------------------------+
#property copyright "AHGDP"
#property link      "TrendEnvelopes_v6"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Magenta
#property indicator_width1 2
#property indicator_color2 Magenta
#property indicator_width2 2
#property indicator_color3 Magenta
#property indicator_width3 1
#property indicator_color4 Magenta
#property indicator_width4 1


extern int     MA_Per_1M      =  44;// "5x8=40" from 75************ 
extern int     MA_Per_5M      =  5;
extern int     MA_Per_15M     =  5;
extern int     MA_Per_30M     =  5;
extern int     MA_Per_60M     =  5;

extern int     MA_SiEmSmWe3   =  2;//********* Smoothed
extern bool    UseDots        =  true;
extern bool    SoundAlert     =  false;
extern int     AlertMode      =  0;

extern int     LineSize       = 3 ;
extern int     ArrowSize      = 2 ;
extern int     CountBars      = 1000;

int TEPAP=0 ;  


double UpBuffer[];
double DnBuffer[];
double UpSignal[];
double DnSignal[]; 
double smax[];
double smin[];
double trend[];


int ExtCountedBars=0;
bool UpTrendAlert=false, DownTrendAlert=false;
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int init()
  {
   IndicatorDigits (+0);
   IndicatorBuffers(7);
   SetIndexStyle (0,DRAW_LINE, STYLE_SOLID, LineSize);
   SetIndexBuffer(0,UpBuffer);
   SetIndexStyle (1,DRAW_LINE, STYLE_SOLID, LineSize);
   SetIndexBuffer(1,DnBuffer);
   
   SetIndexStyle (2,DRAW_ARROW, STYLE_SOLID, ArrowSize);
   SetIndexBuffer(2,UpSignal);
   SetIndexArrow (2,181);//********108************************************
   SetIndexStyle (3,DRAW_ARROW, STYLE_SOLID, ArrowSize);
   SetIndexBuffer(3,DnSignal);
   SetIndexArrow (3,181);//***********************************************
   
   SetIndexBuffer(4,smax);
   SetIndexBuffer(5,smin);
   SetIndexBuffer(6,trend);

//==============================================================================
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int start()
  { 
   int limit;
   if(Bars<=TEPAP) return(0);
   ExtCountedBars=IndicatorCounted();

   if (ExtCountedBars<0) return(-1);

   if (ExtCountedBars>0) ExtCountedBars--;
   
     limit=Bars-CountBars;
   
     SetIndexDrawBegin(0,Bars-CountBars);
     SetIndexDrawBegin(1,Bars-CountBars);
     SetIndexDrawBegin(2,Bars-CountBars);
     SetIndexDrawBegin(3,Bars-CountBars);
     
//======================  CHANGE PERIOD   ======================================   
    switch(Period()) 
  { case 1:    TEPAP = MA_Per_1M   ; break;
    case 5:    TEPAP = MA_Per_5M   ; break;
    case 15:   TEPAP = MA_Per_15M  ; break;
    case 30:   TEPAP = MA_Per_30M  ; break;
    case 60:   TEPAP = MA_Per_60M  ; break;
    case 240:  TEPAP = MA_Per_60M  ; break;
    case 1440: TEPAP = MA_Per_60M  ; break;
    case 10080:TEPAP = MA_Per_60M  ; break;
    case 43200:TEPAP = MA_Per_60M  ; break;
  } 
//==============================================================================       
   
         {    string  ThisName = "TEV";
              string Text=ThisName;
              Text=Text+"(";
              Text=Text+"Per "+DoubleToStr(TEPAP,0);
              Text=Text+", Ma "+DoubleToStr(MA_SiEmSmWe3,0);
              Text=Text+")";
              IndicatorShortName(Text); 
         }        
//==============================================================================  
   for(int i=limit; i>=0; i--)
     { 
      smax[i] = iMA(NULL,0,TEPAP,0,MA_SiEmSmWe3,PRICE_HIGH,i);
      smin[i] = iMA(NULL,0,TEPAP,0,MA_SiEmSmWe3,PRICE_LOW,i);
   
      trend[i]=trend[i+1]; 
	   
	   if (Close[i]>smax[i+1])  trend[i]=1; 
	   if (Close[i]<smin[i+1])  trend[i]=-1;

	   if(trend[i]>0)
	   {
	   if (smin[i]<smin[i+1]) smin[i]=smin[i+1];
	   UpBuffer[i]=smin[i];
	     if (UseDots==true)
	     { 
	        if (trend[i+1]<0) 
	        {
	        UpSignal[i] = smin[i];
	        if (SoundAlert==true && i==0) PlaySound("alert2.wav");
	        }
	        else UpSignal[i] = EMPTY_VALUE;
	     }
	   DnBuffer[i]=EMPTY_VALUE;
	   DnSignal[i]=EMPTY_VALUE; 
	   }
	   else
	   {
	   if(smax[i]>smax[i+1]) smax[i]=smax[i+1];
	   DnBuffer[i]=smax[i];
	     if (UseDots==true)
	     { 
	        if (trend[i+1]>0) 
	        {
	        DnSignal[i] = smax[i];
	        if (SoundAlert==true && i==0) PlaySound("alert2.wav");
	        }
	        else DnSignal[i] = EMPTY_VALUE;
	     }
	   UpBuffer[i]=EMPTY_VALUE;
	   UpSignal[i]=EMPTY_VALUE; 
	   }
   }
//-------------------------------------------------------------------   
   string Message;
   
   if ( trend[2]<0 && trend[1]>0 && Volume[0]>1 && !UpTrendAlert)
	  {
	  Message = " "+Symbol()+" M"+Period()+": Signal for BUY";
	  if ( AlertMode>0 ) Alert (Message); 
	  UpTrendAlert=true; DownTrendAlert=false;
	  } 
	 	  
	  if ( trend[2]>0 && trend[1]<0 && Volume[0]>1 && !DownTrendAlert)
	  {
	  Message = " "+Symbol()+" M"+Period()+": Signal for SELL";
	  if ( AlertMode>0 ) Alert (Message); 
	  DownTrendAlert=true; UpTrendAlert=false;
	  } 	         
//---- done
   return(0);
  }
//+------------------------------------------------------------------+